import QtQuick
import QtQuick.Window
import QtQuick.Layouts
import QtQuick.Controls

Window {
    id: window
    width: 700
    height: 600
    visible: true

    Flickable {
        anchors.fill: parent
        contentWidth: width
        contentHeight: grid.height
        GridLayout {        // GridLayout is used to dynamically switched between RowLayout and ColumnLayout behavior
            id: grid
            anchors.left: parent.left
            anchors.right: parent.right
            columns: 1
            onWidthChanged: {
                // breakpoints
                if (width > 800) {
                    columns = 3;
                } else if (width > 400) {
                    columns = 2;
                } else {
                    columns = 1;
                }
            }

            Box {
                id: header
                text: "Chania"
                fontSize: 50
                color: "#9933cc"
                Layout.columnSpan: grid.columns
            }
            ColumnLayout {
                id: leftBox
                Layout.fillHeight: false
                Box { text: "The Flight" }
                Box { text: "The City" }
                Box { text: "The Island" }
                Box { text: "The Food" }
            }
            ColumnLayout {
                id: contentBox
                Layout.fillHeight: false
                Layout.preferredWidth: 800

                Text { id: text3; text: "The city"; font.pixelSize: 30}
                TextArea {
                    Layout.fillWidth: true
                    Layout.fillHeight: true
                    id: text4
                    text: "Chania is the capital of the Chania region on the island of Crete. The city can be divided in two parts, the old town and the modern city."
                    font.pixelSize: 14
                }
            }
            ColumnLayout {
                id: rightBox
                Layout.alignment: Qt.AlignTop   //
                Box { text: "What?" }
                Box { text: "Where?" }
                Box { text: "How?" }
            }

            Box {
                id: footer
                text: "About this layout"
                fontSize: 10
                color: "#9933cc"
                Layout.columnSpan: grid.columns
            }
        }
    }
}
